#include <stdio.h>

typedef double real;

static real ST[64];
static unsigned _ = 0;

static void Push() { ++_; }
static void Pop()  { --_; }

static void LDI(real d)    { Push(); ST[_]=d; }
static void LD(unsigned p) { LDI(ST[_-p]); }
static void STP(unsigned p) { ST[_-p]=ST[_]; Pop(); }

static void MUL(unsigned p, int push) { real v = ST[_-p], t = ST[_]; if(push)Push(); ST[_] = t * v; }
static void ADD(unsigned p, int push) { real v = ST[_-p], t = ST[_]; if(push)Push(); ST[_] = t + v; }
static void SUB(unsigned p, int push) { real v = ST[_-p], t = ST[_]; if(push)Push(); ST[_] = t - v; }

static int COM(int dir) { real v = ST[_-1] - ST[_]; Pop(); Pop(); return (dir<0)?v<0:dir>0?v>0:(v==0); }
static void POPC(void) { putchar((char)ST[_]); Pop(); }

static const unsigned ymax = 24;
static const unsigned xmax = 78;
static const real XMin = -2.05;
static const real XMax = +1.05;
static const real YMin = -1.4;
static const real YMax = +1.4;

int main(int argc, const char *const *argv)
{	
	LDI((YMax-YMin)/ymax);
	LDI((XMax-XMin)/xmax);
	
	LDI(YMin);    // st0=IP
	LDI(0);       // st1=IP, st0=y

P1:	LDI(XMin);    // st4=ia, st3=ra, st2=IP, st1=y, st0=RP
	LDI(0);       // st5=ia, st4=ra, st3=IP, st2=y, st1=RP, st0=x
	
P2: LDI(0);       // st4=IP, st3=y, st2=RP, st1=x, st0=c

	LD(2);        // st5=IP, st4=y, st3=RP, st2=x, st1=c, st0=x0
	LD(5);        // st6=IP, st5=y, st4=RP, st3=x, st2=c, st1=x0, st0=y0
	
P3:	LD(0);        // st7=IP, st6=y, st5=RP, st4=x, st3=c, st2=x0, st1=y0, st0=y0
	MUL(0, 0);    // st7=IP, st6=y, st5=RP, st4=x, st3=c, st2=x0, st1=y0, st0=y1
	LD(2);        // st8=IP, st7=y, st6=RP, st5=x, st4=c, st3=x0, st2=y0, st1=y1, st0=x0
	MUL(0, 0);    // st8=IP, st7=y, st6=RP, st5=x, st4=c, st3=x0, st2=y0, st1=y1, st0=x1
	
	ADD(1, 1);    // st9=IP, st8=y, st7=RP, st6=x, st5=c, st4=x0, st3=y0, st2=y1, st1=x1, st0=x1+y1
	LDI(4);
	if(COM(1)) goto P4;
	
	LD(3);        // st9=IP, st8=y, st7=RP, st6=x, st5=c, st4=x0, st3=y0, st2=y1, st1=x1, st0=x0
	MUL(3, 0);    // st9=IP, st8=y, st7=RP, st6=x, st5=c, st4=x0, st3=y0, st2=y1, st1=x1, st0=x0*y0
	ADD(0, 0);    // st9=IP, st8=y, st7=RP, st6=x, st5=c, st4=x0, st3=y0, st2=y1, st1=x1, st0=x0*y0*2
	ADD(9, 0);    // st9=IP, st8=y, st7=RP, st6=x, st5=c, st4=x0, st3=y0, st2=y1, st1=x1, st0=x0*y0*2+IP

	STP(3);       // st8=IP, st7=y, st6=RP, st5=x, st4=c, st3=x0, st2=y0, st1=y1, st0=x1
	SUB(1, 0);    // st8=IP, st7=y, st6=RP, st5=x, st4=c, st3=x0, st2=y0, st1=y1, st0=x1-y1
	ADD(6, 0);    // st8=IP, st7=y, st6=RP, st5=x, st4=c, st3=x0, st2=y0, st1=y1, st0=x1-y1+RP

	STP(3);       // st7=IP, st6=y, st5=RP, st4=x, st3=c, st2=x0, st1=y0, st0=y1
	STP(0);       // st6=IP, st5=y, st4=RP, st3=x, st2=c, st1=x0, st0=y0
	
	LDI(1);       // st7=IP, st6=y, st5=RP, st4=x, st3=c, st2=x0, st1=y0, st0=1
	ADD(3, 0);    // st7=IP, st6=y, st5=RP, st4=x, st3=c, st2=x0, st1=y0, st0=1+c
	STP(3);       // st6=IP, st5=y, st4=RP, st3=x, st2=c, st1=x0, st0=y0

	LD(2);
	LDI(63);
	if(COM(1)) goto P6;
	goto P3;
		
P4:	STP(0);       // st7=IP, st6=y, st5=RP, st4=x, st3=c, st2=x0, st1=y0, st0=y1
	STP(0);       // st6=IP, st5=y, st4=RP, st3=x, st2=c, st1=x0, st0=y0

P6:	STP(0);       // st5=ia, st4=ra, st5=IP, st4=y, st3=RP, st2=x, st1=c, st0=x0
	STP(0);       // st6=ia, st5=ra, st4=IP, st3=y, st2=RP, st1=x, st0=c
	
	LDI(96);      // st7=ia, st6=ra, st5=IP, st4=y, st3=RP, st2=x, st1=c, st0=96
	SUB(1, 0);    // st7=ia, st6=ra, st5=IP, st4=y, st3=RP, st2=x, st1=c, st0=96-c
	POPC();       // st6=ia, st5=ra, st4=IP, st3=y, st2=RP, st1=x, st0=c
	
	STP(0);       // st5=ia, st4=ra, st3=IP, st2=y, st1=RP, st0=x
	
	LD(1);        // st6=ia, st5=ra, st4=IP, st3=y, st2=RP, st1=x, st0=RP
	ADD(5, 0);    // st6=ia, st5=ra, st4=IP, st3=y, st2=RP, st1=x, st0=RP+ra
	STP(2);       // st5=ia, st4=ra, st3=IP, st2=y, st1=RP+ra, st0=x
	
	LDI(1);
	ADD(1, 0);
	STP(1);       // st5=ia, st4=ra, st3=IP, st2=y, st1=RP, st0=x+1
	
	LD(0);
	LDI(xmax);
	if(COM(-1)) goto P2;
	
	STP(0);       // st4=ia, st3=ra, st2=IP, st1=y, st0=RP
	STP(0);       // st3=ia, st2=ra, st1=IP, st0=y
	
	LDI(10);
	POPC();
	
	LD(1);        // st4=ia, st3=ra, st2=IP, st1=y, st0=IP
	ADD(4, 0);    // st4=ia, st3=ra, st2=IP, st1=y, st0=IP+ia
	STP(2);       // st3=ia, st2=ra, st1=IP+ia, st0=y
	
	LDI(1);
	ADD(1, 0);
	STP(1);       // st3=ia, st2=ra, st1=IP, st0=y+1

	LD(0);
	LDI(ymax);
	if(COM(-1)) goto P1;
	
	STP(0);
	STP(0);
	STP(0);
	STP(0);
	
	return 0;
}
